Skip to content
SPECIFICTION
Get listed

Boulder vs XiPKI

Boulder

github.com

XiPKI

github.com

Side by side

FigureBoulderXiPKI
Price fromFreeFree
Free planYesYes
Free trial——
Open source——
macOS—Yes
LinuxYesYes
APIYesYes
Self-hostedYesYes
Plans published11
Spec score · Public Key Infrastructure Software8.0 (#9)7.3 (#16)
PurposeBoulder is an ACME-based certificate authority written in Go and is the software that runs Let's Encrypt.XiPKI is an open-source public key infrastructure system covering certification authority, registration authority, and OCSP responder functions, intended for critical infrastructure.
SupportThe maintainers prioritize support and development work that advances Let's Encrypt's mission and warn that timely support may not be available for other deployments.The project directs users to open a GitHub issue and asks bug reports to include test data, logs, version, OS, JRE or JDK, and reproduction steps.

Plans

Boulder

  • Open sourceFree

Boulder pricing →

XiPKI

  • Apache License 2.0Free

XiPKI pricing →

In their own words

Boulder

Boulder is an open-source ACME certificate authority written in Go and used to run Let’s Encrypt. ACME lets a certificate authority verify control of an identifier and allows subscribers to issue or revoke certificates for identifiers they control. Boulder divides its work among web front ends, registration and validation authorities, a certificate authority, storage authority, publisher, and CRL updater. These boundaries separate CA functions by security context, with the certificate authority receiving instructions from the registration authority. Components communicate through gRPC, and the software stores ACME accounts, authorizations, challenges, orders, and certificates. Boulder is free under the Mozilla Public License 2.0 and is listed for API, Linux, and self-hosted use. Maintainers recommend Docker and Docker Compose for development and experimentation, and document connecting Certbot or another ACME client to a local instance. That Docker environment is not suitable for production: it uses publicly available private key material, exposes debug ports, and is described as brittle when components fail. Boulder is built for Let’s Encrypt and Web PKI baseline requirements; maintainers say it often does not fit other organizations’ production needs.

Visit github.com

XiPKI

XiPKI is an open-source public key infrastructure system for certification authority, registration authority, and OCSP responder functions, aimed at critical infrastructure. It supports multiple CAs in one instance, database clusters, and active instances for the same CA, with management through embedded OSGi commands and an API. Its CA gateway supports EST, SCEP, CMP, ACME, and its RESTful API. The OCSP responder handles RFC 2560, RFC 6960, and RFC 5019, along with signed and unsigned requests, health checks, and multiple certificate status sources. HSM connections use PKCS#11; listed devices include AWS CloudHSM, Nitrokey, nCipher, Sansec, SoftHSM, TASS, Thales, and Utimaco. The project describes native support for ML-DSA, ML-KEM, and composite post-quantum algorithms. XiPKI is free under Apache License 2.0. It supports Linux and macOS and requires Java 11 or later and Tomcat 10 or 11. Listed databases include DB2, MariaDB, MySQL, Oracle, PostgreSQL, H2, and HSQLDB.

Visit github.com